%bcond_with oscilloscope
%bcond_with schedutils

Summary: Application tuning GUI & command line utility
Name: tuna
Version: 0.18
Release: 4%{?dist}
License: GPLv2
URL: https://rt.wiki.kernel.org/index.php/Tuna
Source: https://www.kernel.org/pub/software/utils/%{name}/%{name}-%{version}.tar.xz

BuildArch: noarch
BuildRequires: python3-devel, gettext
Requires: python3-ethtool
Requires: python3-linux-procfs >= 0.6
%if %{with schedutils}
Requires: python3-schedutils >= 0.6
%endif

%description
The program can be used to change the attributes of application and kernel
threads. tuna can operate on IRQs by name or number, and tasks or threads
by process ID or command-line. CPUs and sets of CPUs can be specified by
CPU or socket number. IRQ names and process command-lines can include wildcards.

%if %{with oscilloscope}
%package -n oscilloscope
Summary: Generic graphical signal plotting tool
Requires: python3-matplotlib-gtk3 python3-numpy python3-cairocffi
Requires: gobject-introspection tuna = %{version}-%{release}

%description -n oscilloscope
This package provides plots stream of values read from standard input on the
screen together with statistics and a histogram.
%endif



%prep
%autosetup



%build
%py3_build
%py3_shebang_fix tuna/
%py3_shebang_fix tuna-cmd.py

%if %{with oscilloscope}
%py3_shebang_fix oscilloscope-cmd.py
%endif



%install
%py3_install

mkdir -p %{buildroot}/%{_sysconfdir}/tuna/
mkdir -p %{buildroot}/{%{_bindir},%{_datadir}/tuna/help/kthreads,%{_mandir}/man8}
mkdir -p %{buildroot}/%{_datadir}/polkit-1/actions/
install -p -m644 tuna/tuna_gui.glade %{buildroot}/%{_datadir}/tuna/
install -p -m755 tuna-cmd.py %{buildroot}/%{_bindir}/tuna
%if %{with oscilloscope}
install -p -m755 oscilloscope-cmd.py %{buildroot}/%{_bindir}/oscilloscope
%else
rm -f oscilloscope-cmd.py
%endif
install -p -m644 help/kthreads/* %{buildroot}/%{_datadir}/tuna/help/kthreads/
install -p -m644 docs/tuna.8 %{buildroot}/%{_mandir}/man8/
install -p -m644 etc/tuna/example.conf %{buildroot}/%{_sysconfdir}/tuna/
install -p -m644 etc/tuna.conf %{buildroot}/%{_sysconfdir}/
install -p -m644 org.tuna.policy %{buildroot}/%{_datadir}/polkit-1/actions/

for lng in `cat po/LINGUAS`; do
        po=po/"$lng.po"
        mkdir -p %{buildroot}/%{_datadir}/locale/${lng}/LC_MESSAGES
        msgfmt $po -o %{buildroot}/%{_datadir}/locale/${lng}/LC_MESSAGES/%{name}.mo
done

%find_lang %name



%files -f %{name}.lang
%doc ChangeLog
%{python3_sitelib}/*.egg-info
%{_bindir}/tuna
%{_datadir}/tuna/
%{python3_sitelib}/tuna/
%{_mandir}/man8/tuna.8*
%{_sysconfdir}/tuna.conf
%{_sysconfdir}/tuna/*
%{_datadir}/polkit-1/actions/org.tuna.policy

%if %{with oscilloscope}
%files -n oscilloscope
%{_bindir}/oscilloscope
%doc docs/oscilloscope+tuna.html
%doc docs/oscilloscope+tuna.pdf
%endif

%changelog
* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.18-4
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.18-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.18-2
- Rebuilt for OpenCloudOS Stream 23

* Mon Nov 21 2022 cunshunxia <cunshunxia@tencent.com> - 0.18-1
- initial build
